/// <reference types="node" />
import { Account, Borsh, AnyPublicKey } from '@metaplex-foundation/mpl-core';
import BN from 'bn.js';
import { Buffer } from 'buffer';
import { AccountInfo, PublicKey } from '@solana/web3.js';
declare type Args = {
    totalUncancelledBids: BN;
    tickSize: BN | null;
    gapTickSizePercentage: number | null;
    instantSalePrice: BN | null;
    name: number[] | null;
};
export declare class AuctionDataExtended extends Borsh.Data<Args> {
    static readonly SCHEMA: any;
    totalUncancelledBids: BN;
    tickSize: BN | null;
    gapTickSizePercentage: number | null;
    instantSalePrice: BN | null;
    name: number[] | null;
}
export declare class AuctionExtended extends Account<AuctionDataExtended> {
    static readonly DATA_SIZE: number;
    constructor(pubkey: AnyPublicKey, info: AccountInfo<Buffer>);
    static isCompatible(data: Buffer): boolean;
    static getPDA(vault: AnyPublicKey): Promise<PublicKey>;
}
export {};
